#include <stdio.h>

/*
 * __func__ ist kein Makro (siehe Ausgabe von gcc -E),
 * sondern ein vordefinierter Bezeichner, dessen Wert gleich
 * dem Namen (=String) der aktuellen Funktion ist.
 */
#define ASSERT(cond,...) \
	    if (!(cond)) { \
		fprintf(stderr, "%s (%d): %s(): assertion \"%s\" failed\n", \
		    __FILE__, __LINE__, __func__, #cond); \
		__VA_ARGS__ \
	    }

void work() {
    ASSERT(1 == 3)
}

int main() {
    int a = 3;
    ASSERT(a < 0, fprintf(stderr, "DEBUG: a = %d\n", a);)
    work();
    return 0;
}
