#include <stdio.h>

int count = 0;

void work_slow() {
    count++;
}

/*
 * Bei einer Inline-Funktion wird der Code
 * an den Aufruf-Stellen eingefuegt (aehnlich
 * bei Makros, aber ohne Probleme bei Argumenten
 * mit Seiteneffekten, wie z.B. x++).
 * Dazu muss aber dem Compiler mit der Option
 * -O das Optimieren erlaubt werden.
 */
inline void work_fast() {
    count++;
}

int main() {
    for (int i = 0; i < 100000000; i++)
#ifdef FAST
	work_fast();
#else
	work_slow();
#endif
    return 0;
}
